;============================================================
;displays CAnimal info (positions, etc.)
;============================================================
DisplayDinoInfoMain:
push ebp
mov ebp,esp
sub esp,4

;GET BACK BUFFER SURFACE
	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

;TITLE
	invoke TextOut,edi,0,Base_CAnimal_display,canimal_title,[canimal_title_size]

	mov ebx,[CAnimalBuffer]
	test ebx,ebx
	     jz NoDinoDisplay_1

	mov ecx,[DisplayDino_INDEX]
	mov ebx,[ebx+ecx+canimal_info.Instance]       ;ebx=CAnimal instance

	mov eax,[ebx+0DCh]		;CBrain class
	lea edx,[eax+220h]		;instance name

;INSTANCE NAME
	mov ecx,edx
	FINDSTRINGEND ecx
	sub ecx,edx

	invoke TextOut,edi,10h,Base_CAnimal_display+10h,edx,ecx

;INSTANCE BASE ADDRESS
	invoke wsprintf,stack_ext_buffer,canimal_base_addr,ebx
	add esp,12

	invoke TextOut,edi,10h,Base_CAnimal_display+20h,stack_ext_buffer,eax

;LOCATION
	sub esp,24
	fld DWORD [ebx+30h]
	fstp QWORD [esp]
	fld DWORD [ebx+34h]
	fstp QWORD [esp+8]
	fld DWORD [ebx+38h]
	fstp QWORD [esp+16]

	invoke sprintf,stack_ext_buffer,canimal_pos
	add esp,32

	invoke TextOut,edi,10h,Base_CAnimal_display+30h,stack_ext_buffer,eax

;HEALTH
	sub esp,8
	fld DWORD [ebx+50h]
	fstp QWORD [esp]
	invoke sprintf,stack_ext_buffer,canimal_health
	add esp,16

	invoke TextOut,edi,10h,Base_CAnimal_display+40h,stack_ext_buffer,eax

;MAX HEALTH
	sub esp,8
	fld DWORD [ebx+54h]
	fstp QWORD [esp]
	invoke sprintf,stack_ext_buffer,canimal_maxhealth
	add esp,16

	invoke TextOut,edi,10h,Base_CAnimal_display+50h,stack_ext_buffer,eax

;SLEEP/WAKEUP VALUES
	mov eax,[ebx+0DCh]
	sub esp,16
	fld DWORD [eax+344h]
	fld DWORD [eax+340h]
	fstp QWORD [esp+8]
	fstp QWORD [esp]
	invoke sprintf,stack_ext_buffer,canimal_sleepwakeup
	add esp,24

	invoke TextOut,edi,10h,Base_CAnimal_display+60h,stack_ext_buffer,eax

;JUMP INFO
	cmp [UseDisableActJumpNew],0
	    jnz NoDisplayCAnimalJumpInfo
	mov eax,[DisplayDino_INDEX]
	mov edx,[CAnimalBuffer]
	mov ecx,[eax+edx+canimal_info.Count]
	mov eax,sizeof.jump_info
	mul ecx
	mov ecx,[CAnimal_JUMP_Info_BUF]
	test ecx,ecx
	     jz NoDisplayCAnimalJumpInfo
	add ecx,eax

	;ecx = jump_info struc for current instance
	push [ecx+jump_info.LastTickCount]
	push [ecx+jump_info.RepeatPeriod]
	push [ecx+jump_info.JumpTendancy]
	sub esp,16
	fld DWORD [ecx+jump_info.JumpAngle]
	fstp QWORD [esp+8]
	fld DWORD [ecx+jump_info.Push]
	fstp QWORD [esp]

	invoke sprintf,stack_ext_buffer,canimal_jumpinfo
	add esp,36

	invoke TextOut,edi,10h,Base_CAnimal_display+70h,stack_ext_buffer,eax
	NoDisplayCAnimalJumpInfo:

;BRAVERY VALUE
	mov eax,[ebx+0DCh]
	fld DWORD [eax+264h]
	sub esp,8
	fstp QWORD [esp]
	invoke sprintf,stack_ext_buffer,canimal_bravery
	add esp,16

	invoke TextOut,edi,20h,Base_CAnimal_display+80h,stack_ext_buffer,eax

;AI EMOS LOOP
	xor eax,eax
	canimal_emos_display_loop:
	mov [ebp-4],eax
	mov edx,[ebx+0DCh]	;edx=main AI sub-class
	mov ecx,[edx+4h]	;ecx=main emos sub-class
	mov edx,[eax*4+canimal_emos_offsets_table] ;edx=offset in class
	fld DWORD [edx+ecx]
	sub esp,8
	fstp QWORD [esp]
	mov eax,[eax*4+canimal_emos_text_table]
	invoke sprintf,stack_ext_buffer,eax
	add esp,16

	mov ecx,[ebp-4]
	shl ecx,4
	lea ecx,[Base_CAnimal_display+90h+ecx]
	invoke TextOut,edi,20h,ecx,stack_ext_buffer,eax

	mov eax,[ebp-4]
	add eax,1
	cmp eax,canimal_emos_count
	    jb canimal_emos_display_loop

NoDinoDisplay_1:
;RELEASE SURFACE
	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

mov esp,ebp
pop ebp
ret