;============================================================
;This file contains various display procs for various cheats/features
;============================================================

;============================================================
;displays temporary message (5 seconds)
;============================================================
DisplayTempMessage:

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax
	mov ebx,stack_ext_buffer

invoke sprintf,ebx,[TempMessageString],[TempMessageParam1],[TempMessageParam2],\
				       [TempMessageParam3],[TempMessageParam4]
	       add esp,24	       ;params will only be used by function if used in string

invoke TextOut,edi,0,SHOW_TEMP_MSG,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

invoke GetTickCount
       sub eax,[TempMessageTime]
       cmp eax,TEMP_MESSAGE_DISPLAY_INTERVAL
	   jb NoChangeTempMessageTime
       and [TempMessageTime],0
       NoChangeTempMessageTime:

ret

;============================================================
;displays some arbitrary "player" class values (undocumented FAC cheat)
;============================================================
DisplayPlayerFaceFloats:
push ebp
push esi
mov ebp,esp
sub esp,16

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	mov edx,[LocationADDR]
	mov edx,[edx]
	mov esi,[edx+14h]
	mov ebx,stack_ext_buffer
	sub esp,32

	fld DWORD [esi+3Ch]
	fstp QWORD [esp]
	fld DWORD [esi+40h]
	fstp QWORD [esp+8]
	fld DWORD [esi+44h]
	fstp QWORD [esp+16]
	fld DWORD [esi+48h]
	fstp QWORD [esp+24]

invoke sprintf,ebx,ShowFaceFloat_STRING
	add esp,40

invoke TextOut,edi,0,FACE_FLOATS_MSG,ebx,eax

	lea eax,[esi+3Ch]
	lea ecx,[ebp-16]
	call QuatToAxisAngle

	sub esp,32
	fld DWORD [ebp-16]
	fstp QWORD [esp]
	fld DWORD [ebp-12]
	fstp QWORD [esp+8]
	fld DWORD [ebp-8]
	fstp QWORD [esp+16]
	fld DWORD [ebp-4]
	fstp QWORD [esp+24]
invoke sprintf,ebx,ShowFaceFloat_AA_STRING
	add esp,40
invoke TextOut,edi,0,FACE_FLOATS_MSG+10h,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

mov esp,ebp
pop esi
pop ebp
ret

;============================================================
DISPLAYBUFFERSIZES:
;============================================================
	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax
	mov ebx,stack_ext_buffer

	invoke wsprintf,ebx,BUFSIZE_str,[BUFSIZE_map_bitmap],[CAnimalBufferSize],\
			[BUFSIZE_canimal_jump],[BUFSIZE_newdinovocals],[MAD_DinoBufSizeTotal]
	add esp,7*4

	invoke DrawText,edi,ebx,eax,BUFSIZE_rect,DT_WORDBREAK+DT_LEFT

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]
ret

;============================================================
DISPLAYOBJCHEAT:
;============================================================
	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax

	mov ebx,stack_ext_buffer

	invoke sprintf,ebx,ObjOutput_1_STR,[ObjCheatCurrentObject]
	add esp,12
	invoke TextOut,edi,0,OBJ_CHEAT_MSG+00h,ebx,eax

;retrieve object velocity & "rotational velocity"
	mov edx,[ObjCheatCurrentObject]
	push edx
	mov eax,[edx+28h]
	mov ecx,[eax+0Ch]
	mov edx,[ecx]
	push (stack_ext_buffer+400)
	call DWORD [edx+28h]

;print velocity
	fld DWORD [eax+8]
	fld DWORD [eax+4]
	fld DWORD [eax]
	sub esp,24
	fstp QWORD [esp]
	fstp QWORD [esp+8]
	fstp QWORD [esp+16]
	invoke sprintf,ebx,ObjOutput_2_STR
	add esp,(24+8)
	invoke TextOut,edi,0,OBJ_CHEAT_MSG+10h,ebx,eax

;print "rotational velocity"
	mov eax,(stack_ext_buffer+400+12)
	fld DWORD [eax+12]
	fld DWORD [eax+8]
	fld DWORD [eax+4]
	fld DWORD [eax]
	sub esp,32
	fstp QWORD [esp]
	fstp QWORD [esp+8]
	fstp QWORD [esp+16]
	fstp QWORD [esp+24]
	invoke sprintf,ebx,ObjOutput_3_STR
	add esp,(32+8)
	invoke TextOut,edi,0,OBJ_CHEAT_MSG+20h,ebx,eax

;print location
	mov edx,[ObjCheatCurrentObject]
	fld DWORD [edx+38h]
	fld DWORD [edx+34h]
	fld DWORD [edx+30h]
	sub esp,24
	fstp QWORD [esp]
	fstp QWORD [esp+8]
	fstp QWORD [esp+16]
	invoke sprintf,ebx,ObjOutput_4_STR
	add esp,(24+8)
	invoke TextOut,edi,0,OBJ_CHEAT_MSG+30h,ebx,eax

;print orientation (quaternion)
	mov edx,[ObjCheatCurrentObject]
	fld DWORD [edx+48h]
	fld DWORD [edx+44h]
	fld DWORD [edx+40h]
	fld DWORD [edx+3Ch]
	sub esp,32
	fstp QWORD [esp]
	fstp QWORD [esp+8]
	fstp QWORD [esp+16]
	fstp QWORD [esp+24]
	invoke sprintf,ebx,ObjOutput_5_STR
	add esp,(32+8)
	invoke TextOut,edi,0,OBJ_CHEAT_MSG+40h,ebx,eax

;print orientation ("Facing" vector)
	mov edx,[ObjCheatCurrentObject]
	push 0
	lea ecx,[edx+3Ch]
	push (stack_ext_buffer+400)
	call CONVERT_TO_FACING_PROC_010 	;(ATX-optimized version of the same EXE proc)

	mov eax,(stack_ext_buffer+400)
	fld DWORD [eax+8]
	fld DWORD [eax+4]
	fld DWORD [eax]
	sub esp,24
	fstp QWORD [esp]
	fstp QWORD [esp+8]
	fstp QWORD [esp+16]
	invoke sprintf,ebx,ObjOutput_6_STR
	add esp,(24+8)
	invoke TextOut,edi,0,OBJ_CHEAT_MSG+50h,ebx,eax

;print object class type
	invoke sprintf,ebx,ObjOutput_7_STR,[ObjCheatClassTypeStr]
	add esp,12
	invoke TextOut,edi,0,OBJ_CHEAT_MSG+60h,ebx,eax

	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

ret


